include "ZeroPage.inc"
include "VVram.inc"
include "Chars.inc"

ext VVram_
ext CellMap_
ext LineRed_

MapWidth equ VVramWidth/2
MapHeight equ VVramHeight/2

Cell_Wall equ 10h
Cell_Item equ 20h
Cell_Mask equ 0f0h

pVVram equ ZW0
pCellMap equ ZW1
pChars equ ZW2


; ptr<byte> VVramPtr(byte x, byte y);
dseg
VVramPtr_@Param1: public VVramPtr_@Param1
VVramPtr_y:
    defs 1
cseg
VVramPtr_: public	VVramPtr_
	psha | pshb
        staa <ZB0
        ldaa #VVramWidth
        ldab VVramPtr_y
        mul
        addb <ZB0
        adca #0
        addb #low VVram_
        adca #high VVram_
        xgdx
	pulb | pula
rts


; void MapToVVram();
cseg
LineChars:
    defb Char_Space, Char_Space, Char_Space, Char_Space ; none
    defb Char_Line_Bottom, Char_Space, Char_Line_Top, Char_Space ; left
    defb Char_Space, Char_Line_Bottom, Char_Space, Char_Line_Top ; right
    defb Char_Line_Bottom, Char_Line_Bottom, Char_Line_Top, Char_Line_Top ; left right
    defb Char_Line_Right, Char_Line_Left, Char_Space, Char_Space ; top
    defb Char_Line_RightBottom, Char_Line_Left, Char_Line_Top, Char_Space ; top left
    defb Char_Line_Right, Char_Line_LeftBottom, Char_Space, Char_Line_Top ; top right
    defb Char_Line_RightBottom, Char_Line_LeftBottom, Char_Line_Top, Char_Line_Top ; top left right
    defb Char_Space, Char_Space, Char_Line_Right, Char_Line_Left ; bottom
    defb Char_Line_Bottom, Char_Space, Char_Line_RightTop, Char_Line_Left ; bottom left
    defb Char_Space, Char_Line_Bottom, Char_Line_Right, Char_Line_LeftTop ; bottom right
    defb Char_Line_Bottom, Char_Line_Bottom, Char_Line_RightTop, Char_Line_LeftTop ; bottom left right
    defb Char_Line_Right, Char_Line_Left, Char_Line_Right, Char_Line_Left ; bottom top
    defb Char_Line_RightBottom, Char_Line_Left, Char_Line_RightTop, Char_Line_Left ; bottom top left
    defb Char_Line_Right, Char_Line_LeftBottom, Char_Line_Right, Char_Line_LeftTop ; bottom top right
    defb Char_Line_RightBottom, Char_Line_LeftBottom, Char_Line_RightTop, Char_Line_LeftTop ; bottom top left right

cseg
MapToVVram_: public MapToVVram_
    psha | pshb
        ldx #VVram_ | stx <pVVram
        ldx #CellMap_ | stx <pCellMap
        ldab #MapHeight
        do
            pshb
                ldab #MapWidth
                do
                    pshb
                        ldx <pCellMap
                        ldaa 0,x | inx
                        stx <pCellMap
                        
                        cmpa #Cell_Wall
                        if eq
                            ldaa #Char_Block
                            bra byChar
                        endif
                        cmpa #Cell_Item
                        if eq
                            ldaa #Char_Item
                            byChar:
                            ldab #2
                            do
                                pshb
                                    ldx <pVVram
                                    ldab #2
                                    do
                                        staa 0,x | inx
                                        inca
                                        decb
                                    while ne | wend
                                    stx <pVVram
                                    psha
                                        ldaa <pVVram+1 | adda #low(VVramWidth-2) | staa <pVVram+1
                                        ldaa <pVVram | adca #high(VVramWidth-2) | staa <pVVram
                                    pula
                                pulb
                                decb
                            while ne | wend
                            bra nextCell
                        endif
                        anda #$0f
                        asla | asla
                        adda #low LineChars | staa <pChars+1
                        ldaa #high LineChars | adca #0 | staa <pChars 
                        ldab #2
                        do
                            pshb
                                ldab #2
                                do
                                    ldx <pChars
                                    ldaa 0,x | inx
                                    stx <pChars
                                    cmpa #Char_Space
                                    if ne
                                        tst LineRed_
                                        if ne
                                            adda #Char_Line_Red-Char_Line_Normal
                                        endif
                                    endif
                                    ldx <pVVram
                                    staa 0,x | inx
                                    stx <pVVram
                                    decb
                                while ne | wend
                                ldaa <pVVram+1 | adda #low(VVramWidth-2) | staa <pVVram+1
                                ldaa <pVVram | adca #high(VVramWidth-2) | staa <pVVram
                            pulb
                            decb
                        while ne | wend
                        nextCell:
                        ldaa <pVVram+1 | adda #low(2-VVramWidth*2) | staa <pVVram+1
                        ldaa <pVVram | adca #high(2-VVramWidth*2) | staa <pVVram
                    pulb
                    decb
                while ne | wend
                ldaa <pVVram+1 | adda #low VVramWidth | staa <pVVram+1
                ldaa <pVVram | adca #high VVramWidth | staa <pVVram
            pulb
            decb
        while ne | wend        
    pulb | pula
rts


; ptr<byte> CellMapPtr(byte x, byte y);
dseg
CellMapPtr_@Param1: public CellMapPtr_@Param1
CellMapPtr_y:
    defs 1
cseg
CellMapPtr_: public	CellMapPtr_
	psha | pshb
        staa <ZB0
        ldaa #MapWidth
        ldab CellMapPtr_y
        mul
        addb <ZB0
        adca #0
        addb #low CellMap_
        adca #high CellMap_
        xgdx
	pulb | pula
rts
